const width = "500";
const height = "500";
const transitionDuration = 1000;
let level = 0; 
let levelLocation = [];
let month_hack = "aug";
let direction = 1;
let circleEnter;
let zoomBox = {'translate':[],'scale':[]};
let table = d3
  .select(".data-table")
  .append("table")
  .attr("class", "table update-table");
let headerName = ["Location", "Percentage", "Actual Number"];
let headers = table
  .append("thead")
  .append("tr")
  .selectAll("th")
  .data(headerName)
  .enter()
  .append("th")
  .text(d => d);
let row = table.append("tbody").selectAll("tr");
//Zoom
let zzoom = d3.zoom()
  .scaleExtent([1, 8])
  .on("zoom", zoomed);

function zoomed() {
  // g.style("stroke-width", 1.5 / d3.event.transform.k + "px");
  g.attr("transform", d3.event.transform); // updated for d3 v4
}

let tooltip = d3
  .select("body")
  .append("div")
  .attr("class", "tooltip")
  .style("opacity", 0);

const svg = d3
  .select("svg")
  .attr("width", width)
  .attr("height", height);
const g = svg.append("g");
const mercator = d3
  .geoMercator()
  .scale(25000)
  .translate([width / 2, height / 2])
  .center([73, 19.7]);
const pathGenerator = d3.geoPath().projection(mercator);
//Zoom
// svg.call(d3.zoom().on('zoom',() =>{
// 	g.attr('transform',event.transform)
// }))

const render = (
  block,
  project,
  beat,
  awc,
  blockData,
  projectData,
  beatData,
  awcData
) => {
  //initail value of tooltip
  let TextValue = null;
  let TooltipVal1 = d => d.properties.svrly_stntd;
  let TooltipVal2 = d => d.properties.mdrtly_stntd;
  let TooltipVal3 = d => d.properties.ht_msrmnt_effcy;
  let ColorValue = d => d.properties.svrly_stunting_percent;
  const fillCellColor = (d, percentageColor, actualColor) => {
    if (d.name == "Percentage") return percentageColor(d.value);
    else if (d.name == "Actual Number") return actualColor(d.value);
  };

  //info-div
  const updateMonth = selectedMonth => {
    switch (month_hack) {
      case "aug":
        selectedMonth = "August";
        break;
      case "sep":
        selectedMonth = "September";
        break;
      case "oct":
        selectedMonth = "October";
        break;
    }
    d3.select(".info-month").text(selectedMonth);
  };

  const updateCategory = updatedCat => {
    d3.select(".info-category").text(updatedCat);
  };


  //makemap
  const makemap = (geojson, tdata) => {
    d3.select('.info-hirar').text(function(){
      let hirarchy = "Palghar";
      levelLocation.forEach(loc=>{
      	hirarchy += ">"+loc;
      })
    	return hirarchy;
    })
    updateMonth();
    if (level == 0 && direction == 1) {
      TextValue = d => d.properties.Block;
    } else if (level == 1 && direction == 1) {
      TextValue = d => d.properties.Project;
      // ActualValue = d => d.properties. 
    } else if (level == 2 && direction == 1) {
      TextValue = d => d.properties.beat_na;
    } else if (level == 2 && direction == 0) {
      TextValue = d => d.properties.beat_na;
    } else if (level == 1 && direction == 0) {
      TextValue = d => d.properties.Project;
    } else if (level == 0 && direction == 0) {
      TextValue = d => d.properties.Block;
    } 
    let min = d3.min(geojson, ColorValue);
    let max = d3.max(geojson, ColorValue);
    let comp = (max - min) / 3;
    let myColor = (v, low, high) => {
        if (v < low) return "#24562B";
        //matte green
        else if (v >= low && v <= high) return "F4BC1C";
        //matte yellow
        else if (v > high) return "#B2022F"; //matte red
    };
     	let tooltipValue = (d) =>{
      let ttv = `<b>${TextValue(d)}</b><br> 
									Actual Value: ${TooltipVal1(d)}<br>
									Moderate Value: ${TooltipVal2(d)}<br>
									Efficiency Value: ${TooltipVal3(d)}<br>`;
     	return ttv;
     	}
        const onMouseOverPoly = d => {
      tooltip
        .transition()
        .duration(200)
        .style("opacity", 0.9);
      tooltip
        .html(tooltipValue(d))
        .style("left", d3.event.pageX + "px")
        .style("top", d3.event.pageY - 30 + "px");
      
    };

    let path = g.selectAll("path").data(geojson);
    let pathEnter = path
      .enter()
      .append("path")
      .attr("d", pathGenerator)
      .attr("class", "boundary")
      .style("fill", d => {
        if(level !== 3){
        	return myColor(ColorValue(d), min + comp, max - comp);
        }else{
         return "rgba(0,0,0,0)";
        }
      })
      .on("mouseover", d => onMouseOverPoly(d))
      .on("mouseout", function(d) {
        tooltip
          .transition()
          .duration(500)
          .style("opacity", 0);
      });

    //text over polygon
    let textLabel = g
      .selectAll("text")
      .data(geojson)
      .enter()
      .append("text")
      .text(d => {
        if (level !== 3) {
          return `${TextValue(d)}(${ColorValue(d)})`;
        } else {
          return "";
        }
      })
      .attr("x", function(d) {
        return pathGenerator.centroid(d)[0];
      })
      .attr("y", function(d) {
        return pathGenerator.centroid(d)[1];
      })
      .attr("text-anchor", "middle")
      .attr("font-family", "sans-serif");

    if (level === 0) {
      textLabel.attr("font-size", "10pt");
    } else if (level === 1) {
      textLabel.attr("font-size", "6pt"); 
    } else if (level === 2) {
      textLabel.attr("font-size", "4pt");
    } 
    

    //update slider color
    const fillSlider = () => {
      leftX2 = +d3.select("line.track-fill").attr("x1") - 15;
      d3.select("line.leftcolor").attr("x2", leftX2);
    };
    //when slider move
    sliderRange.on("onchange", val => {
      fillSlider();
      d3.select("p#value-range").text(val.map(d3.format(".1%")).join("-"));
      let low = (val[0] * 100).toFixed(2);
      let high = (val[1] * 100).toFixed(2);
      
      pathEnter
        .transition()
        .duration(transitionDuration)
        .style("fill", function(d) {
        	if(level !== 3){
          	return myColor(ColorValue(d), low, high);
          }else{
          	return 'rgba(0,0,0,0)';
          }
        });
      
      if(level === 3){
      	circleEnter
        .transition()
        .duration(transitionDuration)
        .style("fill", function(d) {
          	return myColor(ColorValue(d), low, high);
        });
      }
    });
    let updatedCat;
    const updateviz = selectedCat => {
      //update tooltip
      switch (selectedCat) {
        case "1":
          updatedCat = "Severely Stunted Children";
          TooltipVal1 = d => d.properties.svrly_stntd;
  				TooltipVal2 = d => d.properties.mdrtly_stntd;
  				TooltipVal3 = d => d.properties.ht_msrmnt_effcy;
  				ColorValue = d => d.properties.svrly_stunting_percent;
          break;
        case "2":
          updatedCat = "Stunted Children";
          TooltipVal1 = d => d.properties.stunted_child;
  				TooltipVal2 = d => d.properties.mdrtly_stntd;
  				TooltipVal3 = d => d.properties.ht_msrmnt_effcy;
          ColorValue = d => d.properties.stunting_percent;
          break;
        case "3":
          updatedCat = "Severely Wasted Children";
          TooltipVal1 = d => d.properties.svr_wstg;
  				TooltipVal2 = d => d.properties.mdrtly_wstd;
  				TooltipVal3 = d => d.properties.ht_msrmnt_effcy;
          ColorValue = d => d.properties.svr_wasting_percent;
          break;
        case "4":
          updatedCat = "Wasted Children";
          TooltipVal1 = d => d.properties.wasted_child;
  				TooltipVal2 = d => d.properties.mdrtly_wstd;
  				TooltipVal3 = d => d.properties.ht_msrmnt_effcy;
          ColorValue = d => d.properties.wasting_percent;
          break;
        case "5":
          updatedCat = "Severely Underweight Children";
          TooltipVal1 = d => d.properties.svrly_uw;
  				TooltipVal2 = d => d.properties.mdrtly_uw;
  				TooltipVal3 = d => d.properties.wt_msrmnt_effcy;
          ColorValue = d => d.properties.svrly_underweight_percent;
          break;
        case "6":
          updatedCat = "Underweight Children";
          TooltipVal1 = d => d.properties.uw_child;
  				TooltipVal2 = d => d.properties.mdrtly_uw;
  				TooltipVal3 = d => d.properties.wt_msrmnt_effcy;
          ColorValue = d => d.properties.underweight_percent;
          break;
        case "7":
          updatedCat = "New born with low birth rate";
          TooltipVal1 = d => d.properties.nb_lbw;
  				TooltipVal2 = d => "-";
  				TooltipVal3 = d => "-";
          ColorValue = d => d.properties.low_birth_weight_percent;
          break;
      }
      updateCategory(updatedCat);
      min = d3.min(geojson, ColorValue);
      max = d3.max(geojson, ColorValue);
      comp = (max - min) / 3;
      pathEnter
        .transition()
        .duration(transitionDuration)
        .style("fill", function(d) {
        	if(level !== 3){
          return myColor(ColorValue(d), min + comp, max - comp);
          }else{
          	return 'rgba(0,0,0,0)';
          }
        });

      textLabel
        .text(d => {
        if(level !== 3)
          return `${TextValue(d)}(${ColorValue(d)})`;
        })
        .exit()
        .remove();
    };

    
      let updatepoints = () =>{
      	min = d3.min(geojson, ColorValue);
      	max = d3.max(geojson, ColorValue);
      	comp = (max - min) / 3;
      circleEnter
        .transition()
        .duration(transitionDuration)
        .style("fill", d => {
       return myColor(ColorValue(d),min+comp,max-comp)
      }); 
        
        
      }
      
      


    //on category selection
    const dropdownChange = () => {
      let val = document.getElementById("category").value;
      updateviz(val);
      if(level === 3){
      	updatepoints(val);
      }
      updatetable(val);
    };

    const dropdown = d3.select("#category").on("change", dropdownChange);

    //zoomToBoundingBox
    const zoomToBoundingBox = d => {
      let bounds = pathGenerator.bounds(d),
        dx = bounds[1][0] - bounds[0][0],
        dy = bounds[1][1] - bounds[0][1],
        x = (bounds[0][0] + bounds[1][0]) / 2,
        y = (bounds[0][1] + bounds[1][1]) / 2,
        scale = Math.max(
          1,
          Math.min(8, 0.9 / Math.max(dx / width, dy / height))
        ),
        translate = [width / 2 - scale * x, height / 2 - scale * y];
      	zoomBox['translate'].push(translate);
      	zoomBox['scale'].push(scale);
      svg
        .transition()
        .duration(transitionDuration)
        .call(
          zzoom.transform,
          d3.zoomIdentity.translate(translate[0], translate[1])
        	.scale(scale)
        );
    };
    //selectmap
    const selectedSubFeature = (geojson, location) => {
      let selection = [];
      let geomType;
      // if(level === 3 && direction == 0){
      // } 
      geojson.forEach(sel => {
        if (level === 1 ) {
          if (sel.properties.Block === location) {
            selection.push(sel);
          }
        } else if (level === 2 ) {
          if (sel.properties.Project === location) {
            selection.push(sel);
          }
        } else if (level === 3 ) {
          if (sel.properties.beat_na === location) {
            selection.push(sel);
          }
        }
      });
      return selection;
    };

    // select sub points
    const selectedSubPoint = (geojson, location) => {
      let selection = [];
      geojson.forEach(sel => {
        if (sel.properties.beat === location) {
          selection.push(sel);
        }
      });
      return selection;
    };

    const selectedSubData = (csv, location) => { 
      let selection = [];
      csv.forEach(sel => {
        if (level === 1 && direction === 1) {
          if (sel.block_n == location) {
            selection.push(sel);
          }
        } else if (level === 2 && direction === 1) {
          if (sel.project_n == location) {
            selection.push(sel);
          }
        } else if (level === 3 && direction === 1) {
          if (sel.beat_n == location) {
            selection.push(sel); 
          }
        }
        else if (level === 2 && direction === 0) {
          if (sel.project_n === location) {
            selection.push(sel);
          }
        }else if (level === 1 && direction === 0) {
          if (sel.block_n == location) {
            selection.push(sel);
          }
        }else if (level === 0 && direction === 0) {
          if (sel.block_n == location) {
            selection.push(sel);
          }
        }  
      });
      // console.log(selection);
      return selection;
    };
    // clicked
    const clicked = d => {
      if (level < 3){ 
      level++;
      direction = 1;
      zoomToBoundingBox(d);
      let clickedLocation;
      if (level === 1) {
        clickedLocation = d.properties.Block;
      } else if (level === 2) {
        clickedLocation = d.properties.Project;
      } else if (level === 3) {
        clickedLocation = d.properties.beat_na;
      }

      levelLocation.push(clickedLocation);

      let selectedJSON, selectedData;
      let selectedPoints;
      switch (month_hack) {
        case "aug":
          if (level === 1) {
            selectedJSON = project.Aug;
            selectedData = projectData.Aug;
          } else if (level === 2) {
            selectedJSON = beat.Aug;
            selectedData = beatData.Aug;
          } else if (level === 3) {
            selectedJSON = beat.Aug;
            selectedData = awcData.Aug;
            selectedPoints = awc.Aug;
          }
          break;
        case "sep":
          if (level === 1) {
            selectedJSON = project.Sep;
            selectedData = projectData.Sep;
          } else if (level === 2) {
            selectedJSON = beat.Sep;
            selectedData = beatData.Sep;
          } else if (level === 3) {
            selectedJSON = beat.Sep;
            selectedData = awcData.Sep;
            selectedPoints = awc.Sep;
          }
          break;
        case "oct":
          if (level === 1) {
            selectedJSON = project.Oct;
            selectedData = projectData.Oct;
          } else if (level === 2) {
            selectedJSON = beat.Oct;
            selectedData = beatData.Oct;
          } else if (level === 3) {
            selectedJSON = beat.Oct;
            selectedData = awcData.Oct;
            selectedPoints = awc.Oct;
          }
          break;
      }
      let selectedjson = selectedSubFeature(selectedJSON, clickedLocation);
      let selecteddata = selectedSubData(selectedData, clickedLocation);
      g.selectAll("*").remove();
      rowEnter.selectAll("*").remove();
      // tooltip.remove();
      makemap(selectedjson, selecteddata);
      

      
      //Make geopoints for awc
      if(level === 3){
    //onmouseover
    const onMouseOver = d => {
      let PointTextValue = d => d.properties.awc;
      tooltip
        .transition()
        .duration(200)
        .style("opacity", 0.9);
      let pointTT = `<b>${PointTextValue(d)}</b><br> 
									Percentage Value: ${ColorValue(d)}<br>
									Actual Value: ${TooltipVal1(d)}<br>
									Moderate Value: ${TooltipVal2(d)}<br>
									Efficiency Value: ${TooltipVal3(d)}<br>`;
      tooltip
      	.html(pointTT)
        .style("left", d3.event.pageX + "px")
        .style("top", d3.event.pageY - 30 + "px");
      
    }; 
        
        let selectedpoint = selectedSubPoint(selectedPoints,clickedLocation);
      let circle = g.selectAll("circle").data(selectedpoint);
      circleEnter = circle.enter()
      	.append("circle")
      	.attr("cx", d => mercator(d.geometry.coordinates)[0])
      	.attr("cy", d => mercator(d.geometry.coordinates)[1])
        .attr("r", "1px")
        .style("fill", d => {
        return myColor(ColorValue(d), min + comp, max - comp);
      })
        .on("mouseover", d => onMouseOver(d))
      	.on("mouseout", function(d) {
        tooltip
          .transition()
          .duration(500)
          .style("opacity", 0);
      }); 
    let textLabel = g
      .selectAll("text")
      .data(selectedpoint)
      .enter()
      .append("text")
      .text(d => d.properties.awc )
      .attr("x", d => mercator(d.geometry.coordinates)[0]+1)
      .attr("y", d => mercator(d.geometry.coordinates)[1])
      // .attr("text-anchor", "middle")
      .attr("font-family", "sans-serif")
    	.attr("font-size","1px"); 

      }
    }// if condition ends here
    };
    pathEnter.on("click", clicked);
  // makePoint
  const makePoint = geoPoint => {

  };
    //makeTable
    
    let tbdata = [];
    let LocationValue = d => d.Block;
    let PercentageValue = d => d.svrly_stunting_percent;
    let ActualValue = d => d.svrly_stntd; 
    tdata.forEach(d => {
      let temp = {};
      if (level === 0 && direction == 1) {
        LocationValue = d => d.block_n;
      } else if (level === 1 && direction == 1) {
        LocationValue = d => d.project_n;
      } else if (level === 2 && direction == 1) {
        LocationValue = d => d.beat_n;
      } else if (level === 3 && direction == 1) {
        LocationValue = d => d.awc_with_code;
      } else if(level === 2 && direction === 0){
      	LocationValue = d => d.beat_n;
      } else if (level === 1 && direction == 0) {
        LocationValue = d => d.project_n;
      } else if (level === 0 && direction == 0) {
        LocationValue = d => d.block_n;
      }

      temp["Location"] = LocationValue(d);
      temp["Percentage"] = PercentageValue(d);
      temp["Actual Number"] = ActualValue(d);
      tbdata.push(temp);
    });
    let percentageColor = d3
      .scaleSequential()
      .domain([d3.max(tdata, PercentageValue), d3.min(tdata, PercentageValue)])
      .interpolator(d3.interpolateRdYlGn);
    let actualColor = d3
      .scaleSequential()
      .domain([d3.max(tdata, ActualValue), d3.min(tdata, ActualValue)])
      .interpolator(d3.interpolateRdYlGn);

    let rowEnter = row
      .data(tbdata)
      .enter()
      .append("tr");
    let td = rowEnter
      .selectAll("td")
      .data(d => {
        return headerName.map(k => {
          return { value: d[k], name: k };
        });
      })
      .enter()
      .append("td")
      .text(d => d.value)
      .attr("align", "center")
      .style("background-color", d =>
        fillCellColor(d, percentageColor, actualColor)
      );

    const updatetable = selCat => {
      rowEnter.selectAll("*").remove();
      switch (selCat) {
        case "1":
          PercentageValue = d => d.svrly_stunting_percent;
          ActualValue = d => d.svrly_stntd;
          break;
        case "2":
          PercentageValue = d => d.stunting_percent;
          ActualValue = d => d.stunted_child;
          break;
        case "3":
          PercentageValue = d => d.svr_wasting_percent;
          ActualValue = d => d.svr_wstg;
          break;
        case "4":
          PercentageValue = d => d.wasting_percent;
          ActualValue = d => d.wasted_child;
          break;
        case "5":
          PercentageValue = d => d.svrly_underweight_percent;
          ActualValue = d => d.svrly_uw;
          break;
        case "6":
          PercentageValue = d => d.underweight_percent;
          ActualValue = d => d.uw_child;
          break;
        case "7":
          PercentageValue = d => d.low_birth_weight_percent;
          ActualValue = d => d.nb_lbw;
          break;
      }
      let newtbdata = [];
      if (level === 0) {
        LocationValue = d => d.block_n;
      } else if (level === 1) {
        LocationValue = d => d.project_n;
      } else if (level === 2) {
        LocationValue = d => d.beat_n;
      }
      tdata.forEach(d => {
        let temp = {};
        temp["Location"] = LocationValue(d);
        temp["Percentage"] = PercentageValue(d);
        temp["Actual Number"] = ActualValue(d);
        newtbdata.push(temp);
      });

      let percentageColor = d3
        .scaleSequential()
        .domain([
          d3.max(tdata, PercentageValue),
          d3.min(tdata, PercentageValue)
        ])
        .interpolator(d3.interpolateRdYlGn);
      let actualColor = d3
        .scaleSequential()
        .domain([d3.max(tdata, ActualValue), d3.min(tdata, ActualValue)])
        .interpolator(d3.interpolateRdYlGn);

      rowEnter = row
        .data(newtbdata)
        .enter()
        .append("tr");

      let td = rowEnter
        .selectAll("td")
        .data(d => {
          return headerName.map(k => {
            return { value: d[k], name: k };
          });
        })
        .enter()
        .append("td")
        .text(d => d.value)
        .attr("align", "center")
        .style("background-color", d =>
          fillCellColor(d, percentageColor, actualColor)
        );
    };

    d3.select("button").on("click", function() {
      if (level > 0){ level--;
      zoomBox['translate'].pop();zoomBox['scale'].pop();
			
      direction = 0;
      let loc = levelLocation.pop();
      rowEnter.selectAll("*").remove();
      g.selectAll("*").remove();
      let svgTrans = svg.transition().duration(transitionDuration);
      // calculation for zoom
      let transLength = zoomBox.translate.length;
      let scaleLength = zoomBox.scale.length;
      let transX,transY,scaleV;
      if(level !== 0){
        transX = zoomBox.translate[transLength - 1][0];
        transY = zoomBox.translate[transLength - 1][1];
        scaleV = zoomBox.scale[scaleLength-1];
      }
    	if(level === 0)
        svgTrans.call(zzoom.transform, d3.zoomIdentity);
    	else
       svgTrans.call(zzoom.transform,d3.zoomIdentity.translate(transX,transY).scale(scaleV))
      
      updateCategory("Severely Stunted Children");
      let LocationMonth, LocationDataMonth;
      if (level === 0) {
        switch (month_hack) {
          case "aug":
            LocationMonth = block.Aug;
            LocationDataMonth = blockData.Aug;
            break;
          case "sep":
            LocationMonth = block.Sep;
            LocationDataMonth = blockData.Sep;
            break;
          case "oct":
            LocationMonth = block.Oct;
            LocationDataMonth = blockData.Oct;
            break;
        }

        makemap(LocationMonth, LocationDataMonth);
      } else if (level === 1) {

        switch (month_hack) {
          case "aug":
            LocationMonth = project.Aug;
            LocationDataMonth = projectData.Aug;
            break;
          case "sep":     
            LocationMonth = project.Sep;
            LocationDataMonth = projectData.Sep;
            break;
          case "oct":
            LocationMonth = project.Oct;
            LocationDataMonth = projectData.Oct;
            break;
        }
        let previousBlock = levelLocation[levelLocation.length -1]; 

        let selectedjson = selectedSubFeature(LocationMonth, previousBlock); 
        let selectedcsv = selectedSubData(LocationDataMonth, previousBlock);
         
        makemap(selectedjson, selectedcsv);
      }else if(level === 2){
        switch (month_hack) {
          case "aug":
        		LocationMonth = beat.Aug;
          	LocationDataMonth = beatData.Aug;
            break;
         case "sep":  
            LocationMonth = beat.Sep;
            LocationDataMonth = beatData.Sep;
            break;
          case "oct":
            LocationMonth = beat.Oct;
            LocationDataMonth = beatData.Oct;
            break;
        }             
        //select beats map from project_name
         let previousProject = levelLocation[levelLocation.length -1];
        	let selectedjson = selectedSubFeature(LocationMonth, previousProject); 
          let selectedcsv = selectedSubData(LocationDataMonth, previousProject);
      	  makemap(selectedjson, selectedcsv);
      }
    }//if condition ends here
    });
    const selectGeoJSON = (val, allMonthGeoJSONData) => {
      switch (val) {
        case "aug":
          return allMonthGeoJSONData.Aug;
          break;
        case "sep":
          return allMonthGeoJSONData.Sep;
          break;
        case "oct":
          return allMonthGeoJSONData.Oct;
          break;
      }
    };
    const selectCSV = (val, allMonthCSVData) => {
      switch (val) {
        case "aug":
          return allMonthCSVData.Aug;
          break;
        case "sep":
          return allMonthCSVData.Sep;
          break;
        case "oct":
          return allMonthCSVData.Oct;
          break;
      }
    };

    d3.select("#monthdropdown").on("change", () => {
      let val = document.getElementById("monthdropdown").value;
      month_hack = val;
      let monthjson = selectGeoJSON(val, block);
      let monthdata = selectCSV(val, blockData);
      level = 0;
      g.selectAll("*").remove();
      rowEnter.selectAll("*").remove();
      svg
        .transition()
        .duration(transitionDuration)
        .call(zzoom.transform, d3.zoomIdentity);
      updateMonth();
      levelLocation = [];
      makemap(monthjson, monthdata);
    });
  };

  //initial map
  makemap(block.Aug, blockData.Aug);
};

async function fetchGeoJSON() {
  let geoJSONBundle = {};
  let blockJSON = await d3.json("block.json");
  let projectJSON = await d3.json("project.json");
  let beatJSON = await d3.json("beat.json");
  let awcJSON = await d3.json("awc.json");
  geoJSONBundle.blockJSON = blockJSON.features;
  geoJSONBundle.projectJSON = projectJSON.features;
  geoJSONBundle.beatJSON = beatJSON.features;
  geoJSONBundle.awcJSON = awcJSON.features;
  return geoJSONBundle;
}

const monthWiseCSV = data => {
  let month = { Aug: [], Sep: [], Oct: [] };
  data.forEach(d => {
    let temp = {};
    if (d.project_n) temp.project_n = d.project_n;
    if (d.beat_n) temp.beat_n = d.beat_n;
    if (d.awc_with_code) temp.awc_with_code = d.awc_with_code;

    temp.block_n = d.block_n;
    temp.mdrtly_stntd = +d.mdrtly_stntd;
    temp.svrly_stntd = +d.svrly_stntd;
    temp.svr_wstg = +d.svr_wstg;
    temp.mdrtly_wstd = +d.mdrtly_wstd;
    temp.svrly_uw = +d.svrly_uw;
    temp.mdrtly_uw = +d.mdrtly_uw;
    temp.nb_lbw = +d.nb_lbw;
    temp.svr_wasting_percent = +d.svr_wasting_percent;
    temp.wasting_percent = +d.wasting_percent;
    temp.svrly_stunting_percent = +d.svrly_stunting_percent;
    temp.stunting_percent = +d.stunting_percent;
    temp.svrly_underweight_percent = +d.svrly_underweight_percent;
    temp.underweight_percent = +d.underweight_percent;
    temp.low_birth_weight_percent = +d.low_birth_weight_percent;
    temp.wasted_child = +d.wasted_child;
    temp.stunted_child = +d.stunted_child;
		temp.uw_child = +d.uw_child;
    temp.ht_msrmnt_effcy = +d.ht_msrmnt_effcy;
		temp.wt_msrmnt_effcy = +d.wt_msrmnt_effcy;
    month[d.month_n].push(temp);
    
  });
  return month;
};
const addProperty = (data, geojson) => {
  let x, y;
  for (let i = 0; i < data.length; i++) {
    for (let j = 0; j < geojson.length; j++) {
      if (geojson[j].properties.awc_with_c) {
        x = data[i].awc_with_code;
        y = geojson[j].properties.awc_with_c;
      } else if (geojson[j].properties.beat_na) {
        x = data[i].beat_n;
        y = geojson[j].properties.beat_na;
      } else if (geojson[j].properties.Project) {
        x = data[i].project_n;
        y = geojson[j].properties.Project;
      } else {
        x = data[i].block_n;
        y = geojson[j].properties.Block;
      }

      if (x === y) {
        geojson[j].properties.wasted_child = data[i].wasted_child;
    		geojson[j].properties.stunted_child = data[i].stunted_child;
				geojson[j].properties.uw_child = data[i].uw_child;
    		geojson[j].properties.ht_msrmnt_effcy = data[i].ht_msrmnt_effcy;
				geojson[j].properties.wt_msrmnt_effcy = data[i].wt_msrmnt_effcy;
        geojson[j].properties.mdrtly_stntd = data[i].mdrtly_stntd;
        geojson[j].properties.svrly_stntd = data[i].svrly_stntd;
        geojson[j].properties.svr_wstg = data[i].svr_wstg;
        geojson[j].properties.mdrtly_wstd = data[i].mdrtly_wstd;
        geojson[j].properties.svrly_uw = data[i].svrly_uw;
        geojson[j].properties.mdrtly_uw = data[i].mdrtly_uw;
        geojson[j].properties.nb_lbw = data[i].nb_lbw;
        geojson[j].properties.svr_wasting_percent = data[i].svr_wasting_percent;
        geojson[j].properties.wasting_percent = data[i].wasting_percent;
        geojson[j].properties.svrly_stunting_percent = data[i].svrly_stunting_percent;
        geojson[j].properties.stunting_percent = data[i].stunting_percent;
        geojson[j].properties.svrly_underweight_percent = data[i].svrly_underweight_percent;
        geojson[j].properties.underweight_percent = data[i].underweight_percent;
        geojson[j].properties.low_birth_weight_percent = data[i].low_birth_weight_percent;
      }
    }
  }
};
async function mergeData(geoJSON) {
  //merging block data
  let blockGeoJSON = geoJSON.blockJSON;
  let blockCSV = await d3.csv("block_dummy.csv");
  let blockMonthWiseCSV = monthWiseCSV(blockCSV);
  // console.log(blockMonthWiseCSV);

  let blockGeoJSONAug = JSON.parse(JSON.stringify(blockGeoJSON));
  let blockGeoJSONSep = JSON.parse(JSON.stringify(blockGeoJSON));
  let blockGeoJSONOct = JSON.parse(JSON.stringify(blockGeoJSON));
  //call by reference so need to return
  addProperty(blockMonthWiseCSV.Aug, blockGeoJSONAug);
  addProperty(blockMonthWiseCSV.Sep, blockGeoJSONSep);
  addProperty(blockMonthWiseCSV.Oct, blockGeoJSONOct);
  const mergedBlock = {
    Aug: blockGeoJSONAug,
    Sep: blockGeoJSONSep,
    Oct: blockGeoJSONOct
  };
  //merging project data
  let projectGeoJSON = geoJSON.projectJSON;
  let projectCSV = await d3.csv("project_dummy.csv");
  let projectMonthWiseCSV = monthWiseCSV(projectCSV);
  let projectGeoJSONAug = JSON.parse(JSON.stringify(projectGeoJSON));
  let projectGeoJSONSep = JSON.parse(JSON.stringify(projectGeoJSON));
  let projectGeoJSONOct = JSON.parse(JSON.stringify(projectGeoJSON));
  addProperty(projectMonthWiseCSV.Aug, projectGeoJSONAug);
  addProperty(projectMonthWiseCSV.Sep, projectGeoJSONSep);
  addProperty(projectMonthWiseCSV.Oct, projectGeoJSONOct);
  const mergedProject = {
    Aug: projectGeoJSONAug,
    Sep: projectGeoJSONSep,
    Oct: projectGeoJSONOct
  };

  //merging beat data
  let beatGeoJSON = geoJSON.beatJSON;
  let beatCSV = await d3.csv("beat_dummy.csv");
  let beatMonthWiseCSV = monthWiseCSV(beatCSV);
  let beatGeoJSONAug = JSON.parse(JSON.stringify(beatGeoJSON));
  let beatGeoJSONSep = JSON.parse(JSON.stringify(beatGeoJSON));
  let beatGeoJSONOct = JSON.parse(JSON.stringify(beatGeoJSON));
  addProperty(beatMonthWiseCSV.Aug, beatGeoJSONAug);
  addProperty(beatMonthWiseCSV.Sep, beatGeoJSONSep);
  addProperty(beatMonthWiseCSV.Oct, beatGeoJSONOct);
  const mergedBeat = {
    Aug: beatGeoJSONAug,
    Sep: beatGeoJSONSep,
    Oct: beatGeoJSONOct
  };

  //merging awc data
  let awcGeoJSON = geoJSON.awcJSON;
  let awcCSV = await d3.csv("awc_dummy.csv");
  let awcMonthWiseCSV = monthWiseCSV(awcCSV);
  let awcGeoJSONAug = JSON.parse(JSON.stringify(awcGeoJSON));
  let awcGeoJSONSep = JSON.parse(JSON.stringify(awcGeoJSON));
  let awcGeoJSONOct = JSON.parse(JSON.stringify(awcGeoJSON));
  addProperty(awcMonthWiseCSV.Aug, awcGeoJSONAug);
  addProperty(awcMonthWiseCSV.Sep, awcGeoJSONSep);
  addProperty(awcMonthWiseCSV.Oct, awcGeoJSONOct);

  const mergedAWC = {
    Aug: awcGeoJSONAug,
    Sep: awcGeoJSONSep,
    Oct: awcGeoJSONOct
  };

  render(
    mergedBlock,
    mergedProject,
    mergedBeat,
    mergedAWC,
    blockMonthWiseCSV,
    projectMonthWiseCSV,
    beatMonthWiseCSV,
    awcMonthWiseCSV
  );
}
fetchGeoJSON().then(mergeData);

const sliderRange = d3
  .sliderBottom()
  .min(0)
  .max(0.999)
  .width(300)
  .tickFormat(d3.format(".1%"))
  .ticks(5)
  .default([0.25, 0.5])
  .fill("yellow")
  .handle(
    d3
      .symbol()
      .type(d3.symbolCircle)
      .size(550)()
  );

const gRange = d3
  .select("div#slider-range")
  .append("svg")
  .attr("width", 500)
  .attr("height", 100)
  .append("g")
  .attr("transform", "translate(30,30)");

gRange.call(sliderRange);

let leftX1 = +d3.select("line.track-inset").attr("x1");
let leftX2 = +d3.select("line.track-fill").attr("x1") - 15;
d3.select("g.slider")
  .append("line")
  .attr("class", "leftcolor")
  .attr("x1", leftX1)
  .attr("x2", leftX2)
  .attr("stroke-width", 4)
  .attr("stroke-linecap", "round");

d3.select("line.track-fill").attr("stroke", "yellow");
d3.select("line.leftcolor").attr("stroke", "green");
d3.select("line.track-inset").attr("stroke", "red");